const fs = window.require("fs").promises
const {ipcRenderer} = window.require('electron')
const pathOp = window.require("path")
export async function readDir(filePath){
    const files = await fs.readdir(filePath);
    const fileStateList = []
    const fileChildList = []
    fileStateList.push({
        "fileName": filePath,
        "filePath": filePath,
        "dirFlag": true,
        "children": fileChildList
    })
    for (let i = 0; i < files.length; i++) {
        const state = await fs.stat(filePath + pathOp.sep + files[i]);
        if (state.isDirectory()
            || files[i].endsWith(".md")
            || files[i].endsWith(".html")
            || files[i].endsWith(".lexical")) {
            fileChildList.push({
                'fileName': files[i],
                "filePath": filePath + pathOp.sep + files[i],
                'dirFlag': state.isDirectory(),
                "children":[]
            })
        }
    }
    return fileStateList
}
export async function importFile(pathName) {
    return await fs.readFile(pathName)
}

export async function overWriteFile(filePath,jsonText) {
    await fs.writeFile(filePath,jsonText,{"encoding":"utf-8"})
}

export async function newDir(filePath) {
    await fs.mkdir(filePath)
}
export async function newFile(filePath) {
    await fs.writeFile(filePath,"",{"encoding":"utf-8"})
}
export async function deleteFileAndDir(filePath) {
    await fs.rm(filePath)
}

export async function updateFileName(oldFileName,newFileName){
    await fs.rename(oldFileName,newFileName)
}

export async function saveFileWithName(){
    return ipcRenderer.invoke("saveFileWithName" )
}